# -*- encoding: UTF-8 -*-
r"""
^0 령	# [:ko-KP:]
^0 영
1 일
2 이
3 삼
4 사
5 오
6 륙	# [:ko-KP:]
6 육
7 칠
8 팔
9 구
1(\d) 십$1
(\d)(\d) $1십$2
1(\d\d) 백$1
(\d)(\d\d) $1백$2
1(\d\d\d) 천$1
(\d)(\d\d\d) $1천$2
(\d{1,4})(\d{4}) $1만$2
(\d{1,4})(\d{8}) $1억$2
(\d{1,4})(\d{12}) $1조$2
(\d{1,4})(\d{16}) $1경$2
(\d{1,4})(\d{20}) $1해$2
(\d{1,4})(\d{24}) $1자$2
(\d{1,4})(\d{28}) $1양$2
(\d{1,4})(\d{32}) $1구$2
(\d{1,4})(\d{36}) $1간$2
(\d{1,4})(\d{40}) $1정$2
(\d{1,4})(\d{44}) $1재$2
(\d{1,4})(\d{52}) $1극$2

# negative numbers

[-−](\d+) 음수|$1

# decimals?

"([-−]?\d+)[.]" "$1|점"
"([-−]?\d+[.]\d*)(\d)" $1||$2

# currency

# unit/subunit

us:([^,]*),([^,]*),([^,]*),([^,]*) \1
up:([^,]*),([^,]*),([^,]*),([^,]*) \2
ss:([^,]*),([^,]*),([^,]*),([^,]*) \3
sp:([^,]*),([^,]*),([^,]*),([^,]*) \4

AUD:(\D+) $(\1: 호주달러, 호주달러, 센트, 센트)
EUR:(\D+) $(\1: 유로, 유로, 센트, 센트)
GBP:(\D+) $(\1: 파운드, 파운드, 페니, 펜스)
CNY:(\D+) $(\1:위안, 위안, 펀, 펀)
TWD:(\D+) $(\1:대만달러, 대만달러, 펀, 펀)
HKD:(\D+) $(\1:홍콩달러, 홍콩달러, 센트, 센트)
JPY:(\D+) $(\1:엔, 엔, 센, 센)
KPW:(\D+) $(\1:원, 원 전, 전)
KRW:(\D+) $(\1:원, 원, 전, 전)
SGD:(\D+) $(\1: 싱가포르달러, 싱가포르달러, 센트, 센트)
THB:(\D+) $(\1: 바트, 바트, 사탕, 사탕)
USD:(\D+) $(\1:달러, 달러, 센트, 센트)


"(JPY [-−]?\d+)[.](\d\d)0" $1
"(JPY [-−]?\d+[.]\d\d)(\d)" $1 $2 린

"([A-Z]{3}) ([-−]?1)([.]00?)?" $2$(\1:us)
"([A-Z]{3}) ([-−]?\d+)([.]00?)?" $2$(\1:up)

"(CNY [-−]?\d+)[.](\d)0?" $1 $2 자오
"(CNY [-−]?\d+[.]\d)(\d)" $1 $2 펀

"(TWD [-−]?\d+)[.](\d)0?" $1 $2 자오
"(TWD [-−]?\d+[.]\d)(\d)" $1 $2 펀


"(([A-Z]{3}) [-−]?\d+)[.](01)" $1 |$(1)$(\2:ss)
"(([A-Z]{3}) [-−]?\d+)[.](\d)" $1 |$(\30)$(\2:sp)
"(([A-Z]{3}) [-−]?\d+)[.](\d\d)" $1 |$3$(\2:sp)


== money ==

"(JPY [-−]?\d+)[.](\d\d)0" $1
"(JPY [-−]?\d+[.]\d\d)(\d)" $1 $2 린

"([A-Z]{3}) ([-−]?1)([.]00?)?" $2$(\1:us)
"([A-Z]{3}) ([-−]?\d+)([.]00?)?" $2$(\1:up)

"(CNY [-−]?\d+)[.](\d)0?" $1 $2 자오
"(CNY [-−]?\d+[.]\d)(\d)" $1 $2 펀

"(TWD [-−]?\d+)[.](\d)0?" $1 $2 자오
"(TWD [-−]?\d+[.]\d)(\d)" $1 $2 펀

"([A-Z]{3}) ([-−]?1)" $2$(\1:us)
"([A-Z]{3}) ([-−]?\d+)" $2$(\1:up)
"(([A-Z]{3}) ([-−]?\d+))[.](01)" $3 and 1/100$(\2:us)
"(([A-Z]{3}) ([-−]?\d+))[.](\d)" $3 and \40/100$(\2:up)
"(([A-Z]{3}) ([-−]?\d+))[.](\d\d)" $3 and \4/100$(\2:up)
"(([A-Z]{3}) ([-−]?\d+))[.](\d\d\d)" $3 and \4/1000$(\2:up)

"""
from __future__ import unicode_literals
